$regfile = "m8def.dat"                                      ' ATmega 8
$crystal = 1000000                                          ' 1 MHz
$hwstack = 128
$swstack = 128
$framesize = 128
$baud = 9600
$lib "dcf77.lbx"


' ----- Konfiguration LCD Display -----
Config Lcd = 40 * 4
Config Lcdpin = Pin , Db4 = Portd.0 , Db5 = Portd.1 , Db6 = Portd.3 , Db7 = Portd.4 , E = Portd.6 , E2 = Portd.7 , Rs = Portd.5
Dim ___lcdno As Byte

Initlcd
Waitms 200
Cursor Off Noblink
Cls


' ----- Konfiguration DCF77 -----
Config Dcf77 = Pind.2 , Timer = 1 , Timer1sec = 1 , Debug = 1 , Check = 2 , Update = 0 , Inverted = 0 , Gosub = Sectic
Config Date = Dmy , Separator = .


Idcf Alias Pind.3
Reset Portd.3                                               ' pull-up- off; wichtig !!!

Oled Alias Portd.5
Config Oled = Output

Dcfpon Alias Portc.1
Config Dcfpon = Output
Set Dcfpon

$baud = 19200

Const Myversion1 = "-DCF77-"
Const Myversion2 = " V 2.7 "


Declare Sub Showtime_lcd()
Declare Sub Init

Dim Lftag As Byte
Dim Tz As Byte

Print Myversion1 ; Myversion2

Reset Oled
Set Dcfpon
Set Oled
Call Init
Reset Oled
Reset Dcfpon

Cls
Enable Interrupts


'****************** HAUPTPROGRAMMSCHLEIFE **********************************
'
Do

  If Idcf = 1 Then
    Set Oled
  Else
    Reset Oled
  End If

Loop

End

'optional, is called every second by the library
Sectic:
If Dcf_status.7 = 1 Then
  Call Showtime_lcd()
Else
    Locate 1 , 1
    Lcd "sync"
    Locate 2 , 1
    Lcd Time$
    Print Date$ ; "  " ; Time$
End If

Return


'************* ENDE HAUPTPROGRAMM ******************************************
Sub Init
 Initlcd
 Cls
 Locate 1 , 1 : Lcd Myversion1
 Locate 2 , 1 : Lcd Myversion2
 Wait 50
 Cls
 Cursor Off
End Sub


Sub Showtime_lcd()

  Lftag = Dayofyear()
  Incr Lftag

  Tz = Dcf77timezone()

  Print Date$ ; " " ; Time$ ; " " ; Lftag

  If _sec = 15 Or _sec = 30 Or _sec = 45 Or _
     _sec = 16 Or _sec = 31 Or _sec = 46 Then
    Cls
    Locate 1 , 1
    Lcd Date$
    Locate 2 , 2
    Lcd "T" ; Lftag
  Else
    Cls
    Locate 1 , 1
    If Tz = 1 Then
      Lcd "MEZ"
    Else
      Lcd "MESZ"
    End If
    Locate 2 , 1
    Lcd Time$
  End If


End Sub



End